import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:nan_common_utils/nan_message_channel.dart';
import 'package:nan_common_utils/nan_widget_util.dart';

const VIEW_TYPE = 'com.amap.flutter.map';
class NanMapWidget extends StatefulWidget{

  final String locationImg;
  final String apiKey;
  final double width;
  final double height;
  final double radius;
  final String path;
  NanMapWidget({
    Key key,
    this.locationImg = "location",
    this.apiKey = "36501b8488ba6322b5ec5b7ef40c773f",
    this.width = 50,
    this.height = 50,
    this.radius = 25,
    this.path = "img"
  }):super(key: key);

  @override
  _NanMapWidgetState createState() => _NanMapWidgetState();


}
class _NanMapWidgetState extends State<NanMapWidget>{

  @override
  void initState() {
    super.initState();

  }

  @override
  void dispose() {
    super.dispose();

  }


  @override
  Widget build(BuildContext context) {

    return Stack(
      children: [
        Platform.isIOS?UiKitView(
            viewType: VIEW_TYPE,
            // onPlatformViewCreated: onPlatformViewCreated,
            // gestureRecognizers: gestureRecognizers,
            creationParams: creationParams(),
            creationParamsCodec: const StandardMessageCodec(),
          ):AndroidView(
            viewType: VIEW_TYPE,
            creationParams: creationParams(),
            creationParamsCodec: const StandardMessageCodec(),
          ),
        Positioned(
          top: 80,
          right: 10,
          child: coverageWidget()
        )
      ],
    );
  }

  Widget coverageWidget(){
    return InkWell(
      child: Container(
        width: widget.width,
        height: widget.height,
        padding: EdgeInsets.all(10),
        // margin: EdgeInsets.only(left: widget.left,right: widget.left),
        decoration: BoxDecoration(
          // gradient: LinearGradient(
          //   colors: [Color.fromRGBO(0,227,174, 1),Colous.Color149144]
          // ),
          boxShadow: [
            // BoxShadow(color: Color(0x99FFFF00), offset: Offset(3.0, 3.0), blurRadius: 10.0, spreadRadius: 2.0), 
            BoxShadow(color: Color.fromRGBO(255, 255, 255, 1), offset: Offset(0.5, 0.5)), 
            BoxShadow(color: Color.fromRGBO(	105,105,105, 1))
          ],
          color: Colors.white,
          borderRadius: BorderRadius.all(Radius.circular(widget.radius))
        ),
        
        child: NanWidgetUtil.loadAssetImage(widget.locationImg,width: 30,height: 30,path: widget.path,onTap: () {
          
          // getMovingTrailUnclosedList();
          NanMessageChannel.currentPosition();
        },)
      
    ),
    onTap: (){
      
    },
    );
  }
  // final Map<String, dynamic> creationParams = <String, dynamic>{
  //     'apiKey': "36501b8488ba6322b5ec5b7ef40c773f",
  // };

  Map<String, dynamic> creationParams(){
    return <String, dynamic>{
      'apiKey': widget.apiKey,
    };
  }

}